﻿using System;
using System.Collections;
using System.Collections.Generic;

using Microsoft.BizTalk.Operations;

namespace BizTalkFactory.Management.Automation
{
    public class BtsInstanceCollection : IReadOnlyCollectionWrapper<BtsInstanceCollection>
    {
        private new SortedList<Guid, BtsInstance> collection_ = new SortedList<Guid, BtsInstance>();

        public BtsInstanceCollection(BtsCatalog catalog)
            : base(null)
        {
            BizTalkOperations operations = new BizTalkOperations(catalog.Instance, catalog.Database);
            foreach (Instance instance in operations.GetServiceInstances())
                collection_.Add(instance.ID, BtsInstance.FromItem(catalog, instance));
        }

        #region Overrides

        public override ICollection Collection
        {
            get { return (ICollection)collection_.Values; }
        }

        #endregion
    }
}
