﻿using System;
using System.Collections;
using System.Collections.Generic;

using Microsoft.BizTalk.Operations;

namespace BizTalkFactory.Management.Automation
{
    public class BtsMessageCollection : IReadOnlyCollectionWrapper<BtsMessage>
    {
        private new SortedList<Guid, BtsMessage> collection_ = new SortedList<Guid, BtsMessage>();

        public BtsMessageCollection(BtsCatalog catalog)
            : base(null)
        {
            BizTalkOperations operations = new BizTalkOperations(catalog.Instance, catalog.Database);
            foreach (BizTalkMessage message in operations.GetMessages())
                collection_.Add(message.MessageID, BtsMessage.FromItem(catalog, message));
        }

        #region Overrides

        public override ICollection Collection
        {
            get { return (ICollection)collection_.Values; }
        }

        #endregion
    }
}
