﻿using System;
using System.Collections;
using System.Collections.Generic;

using Microsoft.BizTalk.Operations;

namespace BizTalkFactory.Management.Automation
{
    public class BtsServiceInstanceCollection : IReadOnlyCollectionWrapper<BtsServiceInstance>
    {
        private new SortedList<Guid, BtsServiceInstance> collection_ = new SortedList<Guid, BtsServiceInstance>();

        public BtsServiceInstanceCollection(BtsCatalog catalog)
            : base(null)
        {
            BizTalkOperations operations = new BizTalkOperations(catalog.Instance, catalog.Database);
            foreach (Instance instance in operations.GetServiceInstances())
                collection_.Add(instance.ID, BtsServiceInstance.FromItem(catalog, instance));
        }

        #region Overrides

        public override ICollection Collection
        {
            get { return (ICollection)collection_.Values; }
        }

        #endregion
    }
}
