﻿using System;
using System.Collections;
using System.Collections.Generic;

using Microsoft.BizTalk.Management;
using Microsoft.BizTalk.Operations;

// TODO: do not hardcode BizTalkDTADDb as the name of the Tracking Database

namespace BizTalkFactory.Management.Automation
{
    public class BtsTrackedMessageInstance : BtsArtifact
    {
        private TrackedMessageInstance instance_ = null;

        private BtsTrackedMessageInstance(BtsCatalog catalog, Guid messageInstanceID)
            : base(catalog)
        {
            instance_ = new TrackedMessageInstance(
                  messageInstanceID.ToString("B")
                , "BizTalkDTADb"
                , catalog.Instance);
        }

        public static BtsTrackedMessageInstance GetInstance(BtsCatalog catalog, Guid messageInstanceID)
        {
            return new BtsTrackedMessageInstance(catalog, messageInstanceID);
        }

        #region Attributes

        public override string Name
        {
            get { return Identifier.ToString("D"); }
        }

        public Guid Identifier
        {
            get { return new Guid(instance_.MessageInstanceID); }
        }

        #endregion

        #region Operations

        public void SaveToFolder(string path)
        {
            instance_.SaveToFile(path);
        }

        #endregion
    }
}
