﻿using System;

using Microsoft.BizTalk.Operations;

namespace BizTalkFactory.Management.Automation
{
    public sealed class InstanceStatusConverter
    {
        public static BtsInstanceStatus FromNativeType(InstanceStatus value)
        {
            switch (value)
            {
                case InstanceStatus.Active:
                    return BtsInstanceStatus.Active;
                case InstanceStatus.All:
                    return BtsInstanceStatus.All;
                case InstanceStatus.Completed:
                    return BtsInstanceStatus.Completed;
                case InstanceStatus.Dehydrated:
                    return BtsInstanceStatus.Dehydrated;
                case InstanceStatus.None:
                    return BtsInstanceStatus.None;
                case InstanceStatus.ReadyToRun:
                    return BtsInstanceStatus.ReadyToRun;
                case InstanceStatus.Reserved1:
                    return BtsInstanceStatus.Reserved1;
                case InstanceStatus.RunningAll:
                    return BtsInstanceStatus.RunningAll;
                case InstanceStatus.Scheduled:
                    return BtsInstanceStatus.Scheduled;
                case InstanceStatus.Suspended:
                    return BtsInstanceStatus.Suspended;
                case InstanceStatus.SuspendedAll:
                    return BtsInstanceStatus.SuspendedAll;
                case InstanceStatus.SuspendedNotResumable:
                    return BtsInstanceStatus.SuspendedNotResumable;
                case InstanceStatus.Terminated:
                    return BtsInstanceStatus.Terminated;
            }

            return BtsInstanceStatus.None;
        }

        public static InstanceStatus ToNativeType(BtsInstanceStatus value)
        {
            switch (value)
            {
                case BtsInstanceStatus.Active:
                    return InstanceStatus.Active;
                case BtsInstanceStatus.All:
                    return InstanceStatus.All;
                case BtsInstanceStatus.Completed:
                    return InstanceStatus.Completed;
                case BtsInstanceStatus.Dehydrated:
                    return InstanceStatus.Dehydrated;
                case BtsInstanceStatus.None:
                    return InstanceStatus.None;
                case BtsInstanceStatus.ReadyToRun:
                    return InstanceStatus.ReadyToRun;
                case BtsInstanceStatus.Reserved1:
                    return InstanceStatus.Reserved1;
                case BtsInstanceStatus.RunningAll:
                    return InstanceStatus.RunningAll;
                case BtsInstanceStatus.Scheduled:
                    return InstanceStatus.Scheduled;
                case BtsInstanceStatus.Suspended:
                    return InstanceStatus.Suspended;
                case BtsInstanceStatus.SuspendedAll:
                    return InstanceStatus.SuspendedAll;
                case BtsInstanceStatus.SuspendedNotResumable:
                    return InstanceStatus.SuspendedNotResumable;
                case BtsInstanceStatus.Terminated:
                    return InstanceStatus.Terminated;
            }

            return InstanceStatus.None;
        }
    }
}
