﻿using System;

using Microsoft.BizTalk.Operations;

namespace BizTalkFactory.Management.Automation
{
    public sealed class MessageStatusConverter
    {
        public static BtsMessageStatus FromNativeType(MessageStatus value)
        {
            switch (value)
            {
                case MessageStatus.Active: return BtsMessageStatus.Active;
                case MessageStatus.All: return BtsMessageStatus.All;
                case MessageStatus.QueuedAll: return BtsMessageStatus.QueuedAll;
                case MessageStatus.RetryUndelivered: return BtsMessageStatus.RetryUndelivered;
                case MessageStatus.ScheduledUndelivered: return BtsMessageStatus.ScheduledUndelivered;
                case MessageStatus.State: return BtsMessageStatus.State;
                case MessageStatus.Suspended: return BtsMessageStatus.Suspended;
                case MessageStatus.SuspendedAll: return BtsMessageStatus.SuspendedAll;
                case MessageStatus.SuspendedNotResumable: return BtsMessageStatus.SuspendedNotResumable;
                case MessageStatus.Undelivered: return BtsMessageStatus.Undelivered;
                case MessageStatus.UndeliveredAll: return BtsMessageStatus.UndeliveredAll;
            }

            return BtsMessageStatus.All;
        }

        public static MessageStatus ToNativeType(BtsMessageStatus value)
        {
            switch (value)
            {
                case BtsMessageStatus.Active: return MessageStatus.Active;
                case BtsMessageStatus.All: return MessageStatus.All;
                case BtsMessageStatus.QueuedAll: return MessageStatus.QueuedAll;
                case BtsMessageStatus.RetryUndelivered: return MessageStatus.RetryUndelivered;
                case BtsMessageStatus.ScheduledUndelivered: return MessageStatus.ScheduledUndelivered;
                case BtsMessageStatus.State: return MessageStatus.State;
                case BtsMessageStatus.Suspended: return MessageStatus.Suspended;
                case BtsMessageStatus.SuspendedAll: return MessageStatus.SuspendedAll;
                case BtsMessageStatus.SuspendedNotResumable: return MessageStatus.SuspendedNotResumable;
                case BtsMessageStatus.Undelivered: return MessageStatus.Undelivered;
                case BtsMessageStatus.UndeliveredAll: return MessageStatus.UndeliveredAll;
            }
            return MessageStatus.All;
        }
    }
}