﻿using System;

using Microsoft.BizTalk.Operations;

namespace BizTalkFactory.Management.Automation
{
    public sealed class ServiceClassConverter
    {
        public static BtsServiceClass FromNativeType(ServiceClass value)
        {
            switch (value)
            {
                case ServiceClass.All:
                    return BtsServiceClass.All;
                case ServiceClass.CachingService:
                    return BtsServiceClass.CachingService;
                case ServiceClass.Messaging:
                    return BtsServiceClass.Messaging;
                case ServiceClass.MessagingAll:
                    return BtsServiceClass.MessagingAll;
                case ServiceClass.MSMQT:
                    return BtsServiceClass.MSMQT;
                case ServiceClass.NonCreatableReceiver:
                    return BtsServiceClass.NonCreatableReceiver;
                case ServiceClass.None:
                    return BtsServiceClass.None;
                case ServiceClass.NonSystemAll:
                    return BtsServiceClass.NonSystemAll;
                case ServiceClass.Orchestration:
                    return BtsServiceClass.Orchestration;
                case ServiceClass.RoutingFailure:
                    return BtsServiceClass.RoutingFailure;
                case ServiceClass.Tracking:
                    return BtsServiceClass.Tracking;
            }

            return BtsServiceClass.None;
        }

        public static ServiceClass ToNativeType(BtsServiceClass value)
        {
            switch (value)
            {
                case BtsServiceClass.All:
                    return ServiceClass.All;
                case BtsServiceClass.CachingService:
                    return ServiceClass.CachingService;
                case BtsServiceClass.Messaging:
                    return ServiceClass.Messaging;
                case BtsServiceClass.MessagingAll:
                    return ServiceClass.MessagingAll;
                case BtsServiceClass.MSMQT:
                    return ServiceClass.MSMQT;
                case BtsServiceClass.NonCreatableReceiver:
                    return ServiceClass.NonCreatableReceiver;
                case BtsServiceClass.None:
                    return ServiceClass.None;
                case BtsServiceClass.NonSystemAll:
                    return ServiceClass.NonSystemAll;
                case BtsServiceClass.Orchestration:
                    return ServiceClass.Orchestration;
                case BtsServiceClass.RoutingFailure:
                    return ServiceClass.RoutingFailure;
                case BtsServiceClass.Tracking:
                    return ServiceClass.Tracking;
            }

            return ServiceClass.None;
        }
    }
}
