using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BizTalkFactory.Management.Automation.UnitTests
{
    [TestClass]
    public class ApplicationReferencesTestClass
    {
        private static string reference_ = BizTalkParams.GetUniqueName("R");

        [ClassInitialize]
        public static void Setup(TestContext context)
        {
            BtsCatalog catalog = BizTalkParams.Connect();
            BtsApplication reference = catalog.AddNewApplication(reference_);
        }

        [ClassCleanup]
        public static void TearDown()
        {
            BtsCatalog catalog = BizTalkParams.Connect();
            try { catalog.RemoveApplication(reference_); }
            catch { }
        }

        [TestMethod]
        public void ApplicationReferencesTest()
        {
            string name = BizTalkParams.GetUniqueName("A");

            BtsCatalog catalog = BizTalkParams.Connect();

            try
            {
                BtsApplication reference = catalog.Applications[reference_];
                BtsApplication application = catalog.AddNewApplication(name, new BtsApplication[] { reference });

                Assert.IsNotNull(application);
                Assert.AreEqual(application, catalog.Applications[name]);
                Assert.AreEqual(true, application.References.Contains(reference));
            }
            finally
            {
                try { catalog.RemoveApplication(name); }
                catch { }
            }
        }
    }
 }
