using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BizTalkFactory.Management.Automation.UnitTests
{
    public partial class ApplicationTest
    {
        [TestMethod]
        public void CreateNewApplicationTest()
        {
            string name = BizTalkParams.GetUniqueName("A");

            BtsCatalog catalog = BizTalkParams.Connect();

            try
            {
                BtsApplication application = catalog.AddNewApplication(name);

                Assert.IsNotNull(application);
                Assert.AreEqual(application, catalog.Applications[name]);
            }
            finally
            {
                try { catalog.RemoveApplication(name); }
                catch { }
            }
        }
    }
 }
