using System;
using System.IO;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BizTalkFactory.Management.Automation.UnitTests
{
    [TestClass]
    public class ExportApplicationTestClass
    {
        private static string path = String.Empty;
        private static string name = "BizTalk UnitTest Application";
        private static string package = Path.Combine(Path.GetTempPath(), name + ".msi");

        [ClassInitialize]
        public static void Setup(TestContext context)
        {
            path = BizTalkParams.ExtractResource("BizTalkFactory.UnitTest.Application.dll");

            BtsCatalog catalog = BizTalkParams.Connect();

            BtsApplication application = catalog.AddNewApplication(name);
            BtsResource resource = application.AddNewResource(path);
        }

        [ClassCleanup]
        public static void TearDown()
        {
            BizTalkParams.SafeDeleteFile(package);
            BizTalkParams.SafeDeleteFile(path);

            BtsCatalog catalog = BizTalkParams.Connect();
            try { catalog.RemoveApplication(name, true); } catch { }
            try {  } catch { }
        }

        [TestMethod]
        public void ExportApplicationTest()
        {
            BtsCatalog catalog = BizTalkParams.Connect();

            BtsApplication application = catalog.Applications[name];
            application.Export(package);
            Assert.IsTrue(File.Exists(package));
        }
    }
 }
