using System;
using System.IO;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BizTalkFactory.Management.Automation.UnitTests
{
    [TestClass]
    public class ImportApplicationTestClass
    {
        private static string name = "BizTalk UnitTest Application";
        private static string package = String.Empty;

        [ClassInitialize]
        public static void Setup(TestContext context)
        {
            package = BizTalkParams.ExtractResource(name + ".msi");
        }

        [ClassCleanup]
        public static void TearDown()
        {
            BizTalkParams.SafeDeleteFile(package);

            BtsCatalog catalog = BizTalkParams.Connect();
            try { catalog.RemoveApplication(name, true); }
            catch { }
        }

        [TestMethod]
        public void ImportApplicationTest()
        {
            BtsCatalog catalog = BizTalkParams.Connect();

            Assert.IsFalse(catalog.Applications.TryExists(name));
            catalog.ImportApplication(package);
            Assert.IsTrue(catalog.Applications.TryExists(name));
        }
    }
 }
