using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BizTalkFactory.Management.Automation.UnitTests
{
    [TestClass]
    public class ExportBindingTestClass
    {
        private static string name = BizTalkParams.GetUniqueName("A");

        //[ClassInitialize]
        public static void Setup(TestContext context)
        {
            BtsCatalog catalog = BizTalkParams.Connect();
            BtsApplication application = catalog.AddNewApplication(name);
        }

        //[ClassCleanup]
        public static void TearDown()
        {
            BtsCatalog catalog = BizTalkParams.Connect();
            try { catalog.RemoveApplication(name, true); }
            catch { }
        }

        [TestMethod]
        public void ExportBindingTest()
        {
            BtsCatalog catalog = BizTalkParams.Connect();

            foreach (BtsApplication application in catalog.Applications)
            {
                string destination = System.IO.Path.GetTempFileName();
                string alternate_name = System.IO.Path.Combine(
                    System.IO.Path.GetDirectoryName(destination),
                    System.IO.Path.GetFileNameWithoutExtension(destination) + ".xml"
                );
                application.ExportBinding(destination, false);
                System.IO.File.Move(destination, alternate_name);
                System.Diagnostics.Debug.WriteLine(String.Format("{0} {1}", application.Name, alternate_name));
            }                       
            
            Assert.IsTrue(true);
        }
    }
 }
