using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BizTalkFactory.Management.Automation.UnitTests
{
    public partial class CatalogTest
    {
        [TestMethod]
        public void GetCatalogNameTest()
        {
            BtsCatalog catalog = BtsCatalog.Connect(BizTalkParams.Server, BizTalkParams.Database);
            Assert.AreEqual(catalog.Name, "BizTalk Group");
        }

        [TestMethod]
        public void SetCatalogNameTest()
        {
            string name = "BizTalk Group (UnitTests)";
            string original = String.Empty;

            BtsCatalog catalog = BtsCatalog.Connect(BizTalkParams.Server, BizTalkParams.Database);

            try
            {
                original = catalog.Name;
                catalog.Name = name;
                catalog.Refresh();
                Assert.AreEqual(name, catalog.Name);
            }
            finally
            {
                if (!String.IsNullOrEmpty(original))
                {
                    try { catalog.Name = original; }
                    catch { }
                }
            }
        }
    }
 }
