﻿using System;
using System.Text;

namespace BizTalkFactory.Management.Automation
{
    public class BtsException : ApplicationException
    {
        public BtsException(System.Exception e)
            : base(ExceptionMessage(e), e)
        {
        }

        public BtsException(string message)
            : base(message)
        {
        }

        public BtsException(string message, System.Exception e)
            : base(ExceptionMessage(message, e), e)
        {
        }

        #region Implementation

        private static string ExceptionMessage(string message, System.Exception e)
        {
            return message + Environment.NewLine + ExceptionMessage(e);
        }

        private static string ExceptionMessage(System.Exception e)
        {
            StringBuilder message = new StringBuilder(e.Message);
            while (e.InnerException != null)
            {
                message
                    .Append(Environment.NewLine)
                    .Append(e.InnerException.Message);
                e = e.InnerException;
            }

            return message.ToString();
        }

        #endregion
    }
}
