using System;
using System.Collections.Generic;

namespace BizTalkFactory.Management.Automation
{
    public class BtsOrchestrationCollection : BtsCollection<BtsOrchestration>
    {
        public BtsOrchestrationCollection(BtsApplication application)
            : base(application.Catalog, application.Catalog.BtsCatalogExplorer.Applications[application.Name].Orchestrations)
        {
        }

        public BtsOrchestrationCollection(BtsCatalog catalog)
            : base(catalog, null)
        {
            // BtsCatalogExplorer does not expose an OrchestrationCollection property
            // so we need to manually iterate over all orchestrations within all applications

            List<Microsoft.BizTalk.ExplorerOM.BtsOrchestration> collection = new List<Microsoft.BizTalk.ExplorerOM.BtsOrchestration>();

            foreach (Microsoft.BizTalk.ExplorerOM.Application application in catalog.BtsCatalogExplorer.Applications)
                foreach (Microsoft.BizTalk.ExplorerOM.BtsOrchestration orchestration in application.Orchestrations)
                    collection.Add(orchestration);

            collection_ = collection;
        }
    }
}
