using System;
using System.Collections;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    public class BtsSendPortCollection : BtsCollection<BtsSendPort>
    {
        public BtsSendPortCollection(BtsApplication application)
            : base(application.Catalog, application.Catalog.BtsCatalogExplorer.Applications[application.Name].SendPorts)
        {
        }

        public BtsSendPortCollection(BtsCatalog catalog)
            : base(catalog, catalog.BtsCatalogExplorer.SendPorts)
        {
        }

        public BtsSendPortCollection(BtsSendPortGroup sendPortGroup)
            : base(sendPortGroup.Application.Catalog, sendPortGroup.Catalog.BtsCatalogExplorer.SendPortGroups[sendPortGroup.Name].SendPorts)
        {
        }
    }
}
