using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    public class BtsTransportType
    {
        private BtsCatalog catalog_;
        // internal - visible from BtsTransportInfo        
        internal ProtocolType transportType_;

        internal BtsTransportType(BtsCatalog catalog, ProtocolType transportType)
        {
            catalog_ = catalog;
            transportType_ = transportType;
        }

        #region Attributes

        public BtsCatalog Catalog
        {
            get { return catalog_; }
        }

        public BtsCapabilities Capabilities
        {
            get { return CapabilitiesConverter.FromNativeType(transportType_.Capabilities); }
        }

        public Guid ConfigurationGuid
        {
            get { return transportType_.ConfigurationGuid; }
        }

        public BtsSendHandler DefaultSendHandler
        {
            get { 
                return Helper.BtsHandlerHelper.FindSendHandler(
                    catalog_
                    , transportType_.DefaultSendHandler.Host.Name
                    , transportType_.DefaultSendHandler.TransportType.Name
                    );            
            }
        }

        public string Name
        {
            get { return transportType_.Name; }
        }

        #endregion
    }
}
