using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    internal static class ApplicationStartOptionConverter
    {
        public static BtsApplicationStartOption FromNativeType(ApplicationStartOption value)
        {
            BtsApplicationStartOption option = 0;

            if ((value & ApplicationStartOption.StartAllOrchestrations) == ApplicationStartOption.StartAllOrchestrations)
                option |= BtsApplicationStartOption.StartAllOrchestrations;
            else
                option &= ~BtsApplicationStartOption.StartAllOrchestrations;
            if ((value & ApplicationStartOption.StartAllSendPorts) == ApplicationStartOption.StartAllSendPorts)
                option |= BtsApplicationStartOption.StartAllSendPorts;
            else
                option &= ~BtsApplicationStartOption.StartAllSendPorts;
            if ((value & ApplicationStartOption.StartAllSendPortGroups) == ApplicationStartOption.StartAllSendPortGroups)
                option |= BtsApplicationStartOption.StartAllSendPortGroups;
            else
                option &= ~BtsApplicationStartOption.StartAllSendPortGroups;
            if ((value & ApplicationStartOption.EnableAllReceiveLocations) == ApplicationStartOption.EnableAllReceiveLocations)
                option |= BtsApplicationStartOption.EnableAllReceiveLocations;
            else
                option &= ~BtsApplicationStartOption.EnableAllReceiveLocations;
            if ((value & ApplicationStartOption.DeployAllPolicies) == ApplicationStartOption.DeployAllPolicies)
                option |= BtsApplicationStartOption.DeployAllPolicies;
            else
                option &= ~BtsApplicationStartOption.DeployAllPolicies;
            if ((value & ApplicationStartOption.StartReferencedApplications) == ApplicationStartOption.StartReferencedApplications)
                option |= BtsApplicationStartOption.StartReferencedApplications;
            else
                option &= ~BtsApplicationStartOption.StartReferencedApplications;

            return option;
        }

        public static ApplicationStartOption ToNativeType(BtsApplicationStartOption value)
        {
            ApplicationStartOption option = 0;

            if ((value & BtsApplicationStartOption.StartAllOrchestrations) == BtsApplicationStartOption.StartAllOrchestrations)
                option |= ApplicationStartOption.StartAllOrchestrations;
            else
                option &= ~ApplicationStartOption.StartAllOrchestrations;
            if ((value & BtsApplicationStartOption.StartAllSendPorts) == BtsApplicationStartOption.StartAllSendPorts)
                option |= ApplicationStartOption.StartAllSendPorts;
            else
                option &= ~ApplicationStartOption.StartAllSendPorts;
            if ((value & BtsApplicationStartOption.StartAllSendPortGroups) == BtsApplicationStartOption.StartAllSendPortGroups)
                option |= ApplicationStartOption.StartAllSendPortGroups;
            else
                option &= ~ApplicationStartOption.StartAllSendPortGroups;
            if ((value & BtsApplicationStartOption.EnableAllReceiveLocations) == BtsApplicationStartOption.EnableAllReceiveLocations)
                option |= ApplicationStartOption.EnableAllReceiveLocations;
            else
                option &= ~ApplicationStartOption.EnableAllReceiveLocations;
            if ((value & BtsApplicationStartOption.DeployAllPolicies) == BtsApplicationStartOption.DeployAllPolicies)
                option |= ApplicationStartOption.DeployAllPolicies;
            else
                option &= ~ApplicationStartOption.DeployAllPolicies;
            if ((value & BtsApplicationStartOption.StartReferencedApplications) == BtsApplicationStartOption.StartReferencedApplications)
                option |= ApplicationStartOption.StartReferencedApplications;
            else
                option &= ~ApplicationStartOption.StartReferencedApplications;

            return option;
        }
    }
}
