using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    internal static class ApplicationStatusConverter
    {
        public static BtsApplicationStatus FromNativeType(Status value)
        {
            switch (value)
            {
                case Status.NotApplicable:
                    return BtsApplicationStatus.NotApplicable;
                case Status.Stopped:
                    return BtsApplicationStatus.Stopped;
                case Status.PartiallyStarted:
                    return BtsApplicationStatus.PartiallyStarted;
                case Status.Started:
                    return BtsApplicationStatus.Started;
            }

            return BtsApplicationStatus.NotApplicable;
        }

        public static Status ToNativeType(BtsApplicationStatus value)
        {
            switch (value)
            {
                case BtsApplicationStatus.NotApplicable:
                    return Status.NotApplicable;
                case BtsApplicationStatus.Stopped:
                    return Status.Stopped;
                case BtsApplicationStatus.PartiallyStarted:
                    return Status.PartiallyStarted;
                case BtsApplicationStatus.Started:
                    return Status.Started;
            }

            return Status.NotApplicable;
        }
    }
}
