using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    internal static class ApplicationStopOptionConverter
    {
        public static BtsApplicationStopOption FromNativeType(ApplicationStopOption value)
        {
            BtsApplicationStopOption option = 0;

            if ((value & ApplicationStopOption.UnenlistAllOrchestrations) == ApplicationStopOption.UnenlistAllOrchestrations)
                option |= BtsApplicationStopOption.UnenlistAllOrchestrations;
            else
                option &= ~BtsApplicationStopOption.UnenlistAllOrchestrations;
            if ((value & ApplicationStopOption.UnenlistAllSendPorts) == ApplicationStopOption.UnenlistAllSendPorts)
                option |= BtsApplicationStopOption.UnenlistAllSendPorts;
            else
                option &= ~BtsApplicationStopOption.UnenlistAllSendPorts;
            if ((value & ApplicationStopOption.UnenlistAllSendPortGroups) == ApplicationStopOption.UnenlistAllSendPortGroups)
                option |= BtsApplicationStopOption.UnenlistAllSendPortGroups;
            else
                option &= ~BtsApplicationStopOption.UnenlistAllSendPortGroups;
            if ((value & ApplicationStopOption.DisableAllReceiveLocations) == ApplicationStopOption.DisableAllReceiveLocations)
                option |= BtsApplicationStopOption.DisableAllReceiveLocations;
            else
                option &= ~BtsApplicationStopOption.DisableAllReceiveLocations;
            if ((value & ApplicationStopOption.UndeployAllPolicies) == ApplicationStopOption.UndeployAllPolicies)
                option |= BtsApplicationStopOption.UndeployAllPolicies;
            else
                option &= ~BtsApplicationStopOption.UndeployAllPolicies;
            if ((value & ApplicationStopOption.StopReferencedApplications) == ApplicationStopOption.StopReferencedApplications)
                option |= BtsApplicationStopOption.StopReferencedApplications;
            else
                option &= ~BtsApplicationStopOption.StopReferencedApplications;

            return option;
        }

        public static ApplicationStopOption ToNativeType(BtsApplicationStopOption value)
        {
            ApplicationStopOption option = 0;

            if ((value & BtsApplicationStopOption.UnenlistAllOrchestrations) == BtsApplicationStopOption.UnenlistAllOrchestrations)
                option |= ApplicationStopOption.UnenlistAllOrchestrations;
            else
                option &= ~ApplicationStopOption.UnenlistAllOrchestrations;
            if ((value & BtsApplicationStopOption.UnenlistAllSendPorts) == BtsApplicationStopOption.UnenlistAllSendPorts)
                option |= ApplicationStopOption.UnenlistAllSendPorts;
            else
                option &= ~ApplicationStopOption.UnenlistAllSendPorts;
            if ((value & BtsApplicationStopOption.UnenlistAllSendPortGroups) == BtsApplicationStopOption.UnenlistAllSendPortGroups)
                option |= ApplicationStopOption.UnenlistAllSendPortGroups;
            else
                option &= ~ApplicationStopOption.UnenlistAllSendPortGroups;
            if ((value & BtsApplicationStopOption.DisableAllReceiveLocations) == BtsApplicationStopOption.DisableAllReceiveLocations)
                option |= ApplicationStopOption.DisableAllReceiveLocations;
            else
                option &= ~ApplicationStopOption.DisableAllReceiveLocations;
            if ((value & BtsApplicationStopOption.UndeployAllPolicies) == BtsApplicationStopOption.UndeployAllPolicies)
                option |= ApplicationStopOption.UndeployAllPolicies;
            else
                option &= ~ApplicationStopOption.UndeployAllPolicies;
            if ((value & BtsApplicationStopOption.StopReferencedApplications) == BtsApplicationStopOption.StopReferencedApplications)
                option |= ApplicationStopOption.StopReferencedApplications;
            else
                option &= ~ApplicationStopOption.StopReferencedApplications;

            return option;
        }
    }
}
