using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    internal static class CapabilitiesConverter
    {
        public static BtsCapabilities FromNativeType(Capabilities value)
        {
            BtsCapabilities capabilities = 0;

            if ((value & Capabilities.SupportsReceive) == Capabilities.SupportsReceive)
                capabilities |= BtsCapabilities.SupportsReceive;
            else
                capabilities &= ~BtsCapabilities.SupportsReceive;

            if ((value & Capabilities.SupportsSend) == Capabilities.SupportsSend)
                capabilities |= BtsCapabilities.SupportsSend;
            else
                capabilities &= ~BtsCapabilities.SupportsSend;

            if ((value & Capabilities.RequireSingleInstance) == Capabilities.RequireSingleInstance)
                capabilities |= BtsCapabilities.RequireSingleInstance;
            else
                capabilities &= ~BtsCapabilities.RequireSingleInstance;

            if ((value & Capabilities.ReceiveIsCreatable) == Capabilities.ReceiveIsCreatable)
                capabilities |= BtsCapabilities.ReceiveIsCreatable;
            else
                capabilities &= ~BtsCapabilities.ReceiveIsCreatable;

            if ((value & Capabilities.ApplicationProtocol) == Capabilities.ApplicationProtocol)
                capabilities |= BtsCapabilities.ApplicationProtocol;
            else
                capabilities &= ~BtsCapabilities.ApplicationProtocol;

            if ((value & Capabilities.DeleteProtected) == Capabilities.DeleteProtected)
                capabilities |= BtsCapabilities.DeleteProtected;
            else
                capabilities &= ~BtsCapabilities.DeleteProtected;

            if ((value & Capabilities.StaticHandlers) == Capabilities.StaticHandlers)
                capabilities |= BtsCapabilities.StaticHandlers;
            else
                capabilities &= ~BtsCapabilities.StaticHandlers;

            if ((value & Capabilities.SupportsRequestResponse) == Capabilities.SupportsRequestResponse)
                capabilities |= BtsCapabilities.SupportsRequestResponse;
            else
                capabilities &= ~BtsCapabilities.SupportsRequestResponse;

            if ((value & Capabilities.SupportsSolicitResponse) == Capabilities.SupportsSolicitResponse)
                capabilities |= BtsCapabilities.SupportsSolicitResponse;
            else
                capabilities &= ~BtsCapabilities.SupportsSolicitResponse;

            if ((value & Capabilities.SupportsSoap) == Capabilities.SupportsSoap)
                capabilities |= BtsCapabilities.SupportsSoap;
            else
                capabilities &= ~BtsCapabilities.SupportsSoap;

            if ((value & Capabilities.InitOutboundProtocolContext) == Capabilities.InitOutboundProtocolContext)
                capabilities |= BtsCapabilities.InitOutboundProtocolContext;
            else
                capabilities &= ~BtsCapabilities.InitOutboundProtocolContext;

            if ((value & Capabilities.InitInboundProtocolContext) == Capabilities.InitInboundProtocolContext)
                capabilities |= BtsCapabilities.InitInboundProtocolContext;
            else
                capabilities &= ~BtsCapabilities.InitInboundProtocolContext;

            if ((value & Capabilities.InitReceiveLocationContext) == Capabilities.InitReceiveLocationContext)
                capabilities |= BtsCapabilities.InitReceiveLocationContext;
            else
                capabilities &= ~BtsCapabilities.InitReceiveLocationContext;

            if ((value & Capabilities.InitTransmitLocationContext) == Capabilities.InitTransmitLocationContext)
                capabilities |= BtsCapabilities.InitTransmitLocationContext;
            else
                capabilities &= ~BtsCapabilities.InitTransmitLocationContext;

            if ((value & Capabilities.SupportsOrderedDelivery) == Capabilities.SupportsOrderedDelivery)
                capabilities |= BtsCapabilities.SupportsOrderedDelivery;
            else
                capabilities &= ~BtsCapabilities.SupportsOrderedDelivery;

            if ((value & Capabilities.InitTransmitterOnServiceStart) == Capabilities.InitTransmitterOnServiceStart)
                capabilities |= BtsCapabilities.InitTransmitterOnServiceStart;
            else
                capabilities &= ~BtsCapabilities.InitTransmitterOnServiceStart;

            return capabilities;
        }
    }
}
