﻿using System;

using Microsoft.BizTalk.ExplorerOM;
using Microsoft.BizTalk.Management;

namespace BizTalkFactory.Management.Automation
{
    internal static class DehydrationBehaviorConverter
    {
        public static BtsDehydrationBehavior FromManagementType(HostSetting.DehydrationBehaviorValues value)
        {
            switch (value)
            {
                case HostSetting.DehydrationBehaviorValues.NULL_ENUM_VALUE:
                    return BtsDehydrationBehavior.Invalid;
                case HostSetting.DehydrationBehaviorValues.Always:
                    return BtsDehydrationBehavior.Always;
                case HostSetting.DehydrationBehaviorValues.Custom:
                    return BtsDehydrationBehavior.Custom;
                case HostSetting.DehydrationBehaviorValues.Never:
                    return BtsDehydrationBehavior.Never;
            }

            return BtsDehydrationBehavior.Invalid;
        }

        public static HostSetting.DehydrationBehaviorValues ToManagementType(BtsDehydrationBehavior value)
        {
            switch (value)
            {
                case BtsDehydrationBehavior.Invalid:
                    return HostSetting.DehydrationBehaviorValues.NULL_ENUM_VALUE;
                case BtsDehydrationBehavior.Always:
                    return HostSetting.DehydrationBehaviorValues.Always;
                case BtsDehydrationBehavior.Custom:
                    return HostSetting.DehydrationBehaviorValues.Custom;
                case BtsDehydrationBehavior.Never:
                    return HostSetting.DehydrationBehaviorValues.Never;
            }

            return HostSetting.DehydrationBehaviorValues.NULL_ENUM_VALUE;
        }
    }
}
