using System;

using Microsoft.BizTalk.ExplorerOM;
using Microsoft.BizTalk.Management;

namespace BizTalkFactory.Management.Automation
{
    internal static class HostTypeConverter
    {
        public static BtsHostType FromNativeType(HostType value)
        {
            switch (value)
            {
                case HostType.Invalid:
                    return BtsHostType.Invalid;
                case HostType.InProcess:
                    return BtsHostType.InProcess;
                case HostType.Isolated:
                    return BtsHostType.Isolated;
            }

            return BtsHostType.Invalid;
        }

        public static BtsHostType FromManagementType(HostSetting.HostTypeValues value)
        {
            switch (value)
            {
                case HostSetting.HostTypeValues.NULL_ENUM_VALUE:
                    return BtsHostType.Invalid;
                case HostSetting.HostTypeValues.In_process:
                    return BtsHostType.InProcess;
                case HostSetting.HostTypeValues.Isolated:
                    return BtsHostType.Isolated;
            }

            return BtsHostType.Invalid;
        }
    }
}
