using System;

using Microsoft.BizTalk.ExplorerOM;
using Microsoft.BizTalk.Management;

namespace BizTalkFactory.Management.Automation
{
    internal static class PipelineTypeConverter
    {
        public static BtsPipelineType FromNativeType(PipelineType value)
        {
            switch (value)
            {
                case PipelineType.Receive:
                    return BtsPipelineType.Receive;
                case PipelineType.Send:
                    return BtsPipelineType.Send;
                case PipelineType.Transform:
                    return BtsPipelineType.Transform;
                case PipelineType.Unknown:
                    return BtsPipelineType.Unknown;
            }

            System.Diagnostics.Debug.Assert(false);
            return BtsPipelineType.Unknown;
        }

        public static PipelineType ToNativeType(BtsPipelineType value)
        {
            switch (value)
            {
                case BtsPipelineType.Receive:
                    return PipelineType.Receive;
                case BtsPipelineType.Send:
                    return PipelineType.Send;
                case BtsPipelineType.Transform:
                    return PipelineType.Transform;
                case BtsPipelineType.Unknown:
                    return PipelineType.Unknown;
            }

            System.Diagnostics.Debug.Assert(false);
            return PipelineType.Unknown;
        }
    }
}
