using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    internal static class PortStatusConverter
    {
        public static BtsPortStatus FromNativeType(PortStatus value)
        {
            switch (value)
            {
                case PortStatus.Stopped:
                    return BtsPortStatus.Stopped;
                case PortStatus.Bound:
                    return BtsPortStatus.Bound;
                case PortStatus.Started:
                    return BtsPortStatus.Started;
            }

            return BtsPortStatus.NotApplicable;
        }

        public static PortStatus ToNativeType(BtsPortStatus value)
        {
            switch (value)
            {
                case BtsPortStatus.Stopped:
                    return PortStatus.Stopped;
                case BtsPortStatus.Bound:
                    return PortStatus.Bound;
                case BtsPortStatus.Started:
                    return PortStatus.Started;
            }

            System.Diagnostics.Debug.Assert(false);
            throw new ArgumentException("Invalid PortStatus specified.");
        }
    }
}
