using System;

using Microsoft.BizTalk.Management;

namespace BizTalkFactory.Management.Automation
{
    internal static class ServiceStateConverter
    {
        public static BtsServiceState FromManagementType(HostInstance.ServiceStateValues value)
        {
            switch (value)
            {
                case HostInstance.ServiceStateValues.NULL_ENUM_VALUE:
                    return BtsServiceState.NotApplicable;
                case HostInstance.ServiceStateValues.Stopped:
                    return BtsServiceState.Stopped;
                case HostInstance.ServiceStateValues.Start_pending:
                    return BtsServiceState.StartPending;
                case HostInstance.ServiceStateValues.Stop_pending:
                    return BtsServiceState.StopPending;
                case HostInstance.ServiceStateValues.Running:
                    return BtsServiceState.Running;
                case HostInstance.ServiceStateValues.Continue_pending:
                    return BtsServiceState.ContinuePending;
                case HostInstance.ServiceStateValues.Pause_pending:
                    return BtsServiceState.PausePending;
                case HostInstance.ServiceStateValues.Paused:
                    return BtsServiceState.Paused;
            }

            return BtsServiceState.NotApplicable;
        }
    }
}
