using System;

using Microsoft.BizTalk.ExplorerOM;

namespace BizTalkFactory.Management.Automation
{
    internal static class TrackingTypesConverter
    {
        public static BtsTrackingTypes FromNativeType(TrackingTypes value)
        {
            BtsTrackingTypes tracking = 0;

            if ((value & TrackingTypes.BeforeReceivePipeline) == TrackingTypes.BeforeReceivePipeline)
                tracking |= BtsTrackingTypes.BeforeReceivePipeline;
            else
                tracking &= ~BtsTrackingTypes.BeforeReceivePipeline;
            if ((value & TrackingTypes.AfterReceivePipeline) == TrackingTypes.AfterReceivePipeline)
                tracking |= BtsTrackingTypes.AfterReceivePipeline;
            else
                tracking &= ~BtsTrackingTypes.AfterReceivePipeline;
            if ((value & TrackingTypes.BeforeSendPipeline) == TrackingTypes.BeforeSendPipeline)
                tracking |= BtsTrackingTypes.BeforeSendPipeline;
            else
                tracking &= ~BtsTrackingTypes.BeforeSendPipeline;
            if ((value & TrackingTypes.AfterSendPipeline) == TrackingTypes.AfterSendPipeline)
                tracking |= BtsTrackingTypes.AfterSendPipeline;
            else
                tracking &= ~BtsTrackingTypes.AfterSendPipeline;
            if ((value & TrackingTypes.TrackPropertiesBeforeReceivePipeline) == TrackingTypes.TrackPropertiesBeforeReceivePipeline)
                tracking |= BtsTrackingTypes.TrackPropertiesBeforeReceivePipeline;
            else
                tracking &= ~BtsTrackingTypes.TrackPropertiesBeforeReceivePipeline;
            if ((value & TrackingTypes.TrackPropertiesAfterReceivePipeline) == TrackingTypes.TrackPropertiesAfterReceivePipeline)
                tracking |= BtsTrackingTypes.TrackPropertiesAfterReceivePipeline;
            else
                tracking &= ~BtsTrackingTypes.TrackPropertiesAfterReceivePipeline;
            if ((value & TrackingTypes.TrackPropertiesBeforeSendPipeline) == TrackingTypes.TrackPropertiesBeforeSendPipeline)
                tracking |= BtsTrackingTypes.TrackPropertiesBeforeSendPipeline;
            else
                tracking &= ~BtsTrackingTypes.TrackPropertiesBeforeSendPipeline;
            if ((value & TrackingTypes.TrackPropertiesAfterSendPipeline) == TrackingTypes.TrackPropertiesAfterSendPipeline)
                tracking |= BtsTrackingTypes.TrackPropertiesAfterSendPipeline;
            else
                tracking &= ~BtsTrackingTypes.TrackPropertiesAfterSendPipeline;

            return tracking;
        }

        public static TrackingTypes ToNativeType(BtsTrackingTypes value)
        {
            TrackingTypes tracking = 0;

            if ((value & BtsTrackingTypes.BeforeReceivePipeline) == BtsTrackingTypes.BeforeReceivePipeline)
                tracking |= TrackingTypes.BeforeReceivePipeline;
            else
                tracking &= ~TrackingTypes.BeforeReceivePipeline;
            if ((value & BtsTrackingTypes.AfterReceivePipeline) == BtsTrackingTypes.AfterReceivePipeline)
                tracking |= TrackingTypes.AfterReceivePipeline;
            else
                tracking &= ~TrackingTypes.AfterReceivePipeline;
            if ((value & BtsTrackingTypes.BeforeSendPipeline) == BtsTrackingTypes.BeforeSendPipeline)
                tracking |= TrackingTypes.BeforeSendPipeline;
            else
                tracking &= ~TrackingTypes.BeforeSendPipeline;
            if ((value & BtsTrackingTypes.AfterSendPipeline) == BtsTrackingTypes.AfterSendPipeline)
                tracking |= TrackingTypes.AfterSendPipeline;
            else
                tracking &= ~TrackingTypes.AfterSendPipeline;
            if ((value & BtsTrackingTypes.TrackPropertiesBeforeReceivePipeline) == BtsTrackingTypes.TrackPropertiesBeforeReceivePipeline)
                tracking |= TrackingTypes.TrackPropertiesBeforeReceivePipeline;
            else
                tracking &= ~TrackingTypes.TrackPropertiesBeforeReceivePipeline;
            if ((value & BtsTrackingTypes.TrackPropertiesAfterReceivePipeline) == BtsTrackingTypes.TrackPropertiesAfterReceivePipeline)
                tracking |= TrackingTypes.TrackPropertiesAfterReceivePipeline;
            else
                tracking &= ~TrackingTypes.TrackPropertiesAfterReceivePipeline;
            if ((value & BtsTrackingTypes.TrackPropertiesBeforeSendPipeline) == BtsTrackingTypes.TrackPropertiesBeforeSendPipeline)
                tracking |= TrackingTypes.TrackPropertiesBeforeSendPipeline;
            else
                tracking &= ~TrackingTypes.TrackPropertiesBeforeSendPipeline;
            if ((value & BtsTrackingTypes.TrackPropertiesAfterSendPipeline) == BtsTrackingTypes.TrackPropertiesAfterSendPipeline)
                tracking |= TrackingTypes.TrackPropertiesAfterSendPipeline;
            else
                tracking &= ~TrackingTypes.TrackPropertiesAfterSendPipeline;

            return tracking;
        }
    }
}
