﻿using System;

namespace BizTalkFactory.Management.Automation
{
    public sealed class BtsPerfCounterServiceClass
    {
        public static BtsPerfCounterServiceClass XLANGs = new BtsPerfCounterServiceClass(new System.Guid("226fc6b9-0416-47a4-a8e8-4721f1db1a1b"));
        public static BtsPerfCounterServiceClass MessagingInProcess = new BtsPerfCounterServiceClass(new System.Guid("59f295b0-3123-416e-966b-a2c6d65ff8e6"));
        public static BtsPerfCounterServiceClass MessagingIsolated = new BtsPerfCounterServiceClass(new System.Guid("683aedf1-027d-4006-ae9a-443d1a5746fc"));
        public static BtsPerfCounterServiceClass MSMQT = new BtsPerfCounterServiceClass(new System.Guid("3d7a3f58-4bfb-4593-b99e-c2a5dc35a3b2"));

        public Guid ClassID;

        public BtsPerfCounterServiceClass(Guid classID)
        {
            ClassID = classID;
        }

        public static explicit operator BtsPerfCounterServiceClass(Guid classID)
        {
            if (classID.CompareTo(XLANGs) == 0)
                return new BtsPerfCounterServiceClass(XLANGs);

            else if (classID.CompareTo(MessagingInProcess) == 0)
                return new BtsPerfCounterServiceClass(MessagingInProcess);

            else if (classID.CompareTo(MessagingIsolated) == 0)
                return new BtsPerfCounterServiceClass(MessagingInProcess);

            else if (classID.CompareTo(MSMQT) == 0)
                return new BtsPerfCounterServiceClass(MSMQT);

            throw new ArgumentException();
        }

        public static implicit operator Guid(BtsPerfCounterServiceClass serviceClass)
        {
            return serviceClass.ClassID;
        }
    }
}