﻿using Microsoft.BizTalk.ExplorerOM;
using System.Xml;
using System.Collections.Generic;
using System;

namespace BizTalkFactory.Management.Automation.Helper
{
    public sealed class BtsSettingsHelper
    {
#if BTS2010
        // Methods
        public static SettingsRoot ParseGroupSettings(string path)
        {
            SettingsRoot root;
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(path);
                List<SettingElement> ls = new List<SettingElement>(1);
                foreach (XmlNode node in document.SelectNodes("/Settings/GroupSettings/Setting"))
                {
                    ls.Add(new SettingElement(node.Attributes["Name"].Value, node.InnerText));
                }
                root = new SettingsRoot(ls);
            }
            catch (Exception exception)
            {
                throw new BtsException(exception);
            }
            return root;
        }

        public static HostInstanceSettings ParseHostInstancesSettings(string path)
        {
            HostInstanceSettings settings;
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(path);
                List<ServerSettingsContainerWithNameAttr> h = new List<ServerSettingsContainerWithNameAttr>();
                foreach (XmlNode node in document.SelectNodes("/Settings/HostInstanceSettings/Host"))
                {
                    List<SettingsContainerWithNameAttr> ser = new List<SettingsContainerWithNameAttr>(1);
                    foreach (XmlNode node2 in node.SelectNodes("Server"))
                    {
                        List<SettingElement> list = new List<SettingElement>(1);
                        foreach (XmlNode node3 in node2.SelectNodes("Setting"))
                        {
                            list.Add(new SettingElement(node3.Attributes["Name"].Value, node3.InnerText));
                        }
                        ser.Add(new SettingsContainerWithNameAttr(node2.Attributes["Name"].Value, list));
                    }
                    h.Add(new ServerSettingsContainerWithNameAttr(node.Attributes["Name"].Value, ser));
                }
                settings = new HostInstanceSettings(h);
            }
            catch (Exception exception)
            {
                throw new BtsException(exception);
            }
            return settings;
        }

        public static HostSettings ParseHostsSettings(string path)
        {
            HostSettings settings;
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(path);
                List<SettingsContainerWithNameAttr> list = new List<SettingsContainerWithNameAttr>();
                foreach (XmlNode node in document.SelectNodes("/Settings/HostSettings/Host"))
                {
                    List<SettingElement> list2 = new List<SettingElement>(1);
                    foreach (XmlNode node2 in node.SelectNodes("Setting"))
                    {
                        list2.Add(new SettingElement(node2.Attributes["Name"].Value, node2.InnerText));
                    }
                    SettingsContainerWithNameAttr item = new SettingsContainerWithNameAttr(node.Attributes["Name"].Value, list2);
                    list.Add(item);
                }
                settings = new HostSettings(list);
            }
            catch (Exception exception)
            {
                throw new BtsException(exception);
            }
            return settings;
        }
#endif
    }
}