using BizTalkFactory.Management.Automation;
using System;
using System.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class BizTalkDriveInfo : PSDriveInfo
    {
        private Catalog biztalk_ = null;
        private BizTalkProvider provider_ = null;
        private BizTalkDriveParameters parameters_ = null;

        public BizTalkDriveInfo(BizTalkProvider provider, PSDriveInfo driveInfo, BizTalkDriveParameters parameters)
            : base(driveInfo)
        {
            provider_ = provider;
            parameters_ = parameters;

            biztalk_ = new Catalog(BtsCatalog.Connect(Instance, Database), driveInfo.Root);
        }

        public BizTalkProvider BizTalkProvider
        {
            get { return provider_; }
        }

        public Catalog Catalog
        {
            get { return biztalk_; }
        }
        
        internal string Database
        {
            get { return parameters_.Database; }
        }

        internal string Instance
        {
            get { return parameters_.Instance; }
        }

        internal string ConnectionString
        {
            get { return String.Format("Data Source={0};Initial Catalog={1};Integrated Security=SSPI;", Instance, Database); }
        }
    }
}
