using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Management.Automation;

using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Deploy", "Policy", DefaultParameterSetName = "PathParameterSet")]
    public class DeployPolicyCommand : BizTalkPolicyCmdlet
    {
        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsPolicy policy = (btsObject as BtsPolicy);
                policy.Deploy();
            }

            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidArgument, btsObject));
            }
        }
    }
}
