using System;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Enable", "ReceiveLocation", DefaultParameterSetName = "PathParameterSet")]
    public class EnableReceiveLocationCommand : BizTalkPathAndObjectCmdlet
    {
        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsReceiveLocation;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsReceiveLocation btsReceiveLocation = btsObject as BtsReceiveLocation;
                RegisterCatalog(btsReceiveLocation.Catalog);
                btsReceiveLocation.Enable = true;
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidOperation, btsObject));
            }
        }

        protected override void EndProcessing()
        {
            SaveChanges();
        }
    }
}
