﻿using System;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Enlist", "SendPortGroup", DefaultParameterSetName = "PathParameterSet")]
    public class EnlistSendPortGroupCommand : BizTalkPathAndObjectCmdlet
    {
        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsSendPortGroup;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsSendPortGroup btsSendPortGroup = btsObject as BtsSendPortGroup;
                RegisterCatalog(btsSendPortGroup.Catalog);
                btsSendPortGroup.Enlist();
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidOperation, btsObject));
            }
        }
        
        protected override void EndProcessing()
        {
            SaveChanges();
        }
    }
}
