using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Management.Automation;

using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Export", "Policy", DefaultParameterSetName = "PathParameterSet")]
    public class ExportPolicyCommand : BizTalkPolicyCmdlet
    {
        private string destination_ = String.Empty;
        private bool add_referenced_vocabularies_ = false;

        [Parameter(Mandatory = true)]
        [ValidateNotNullOrEmpty]
        public string Destination
        {
            get { return destination_; }
            set { destination_ = value; }
        }

        [Parameter()]
        public SwitchParameter AddReferencedVocabularies
        {
            get { return add_referenced_vocabularies_; }
            set { add_referenced_vocabularies_ = value; }
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsPolicy policy = (btsObject as BtsPolicy);
                policy.Application.ExportPolicy(policy, destination_, add_referenced_vocabularies_);
            }

            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidArgument, btsObject));
            }
        }
    }
}
