using System;
using System.Collections.ObjectModel;
using System.Management.Automation;
using System.Diagnostics;
using BizTalkFactory.Management.Automation;
using BizTalkFactory.Management.Automation.Helper;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Get", "ApplicationResourceSpec", DefaultParameterSetName = "PathParameterSet")]
    public class GetApplicationResourceSpecCommand : BizTalkPathAndObjectCmdlet
    {
        public GetApplicationResourceSpecCommand()
            : base(true)
        {}

        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsApplication;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsApplication btsApplication = btsObject as BtsApplication;
                WriteObject(BtsApplicationHelper.GetResourceSpec(btsApplication));
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidArgument, btsObject));
            }
        }
    }
}
