using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Management.Automation;

using BizTalkFactory.Management.Automation;

// TODO: major refactoring
// use a separate Application\<application name>\Policies\ folder
// do not show policies under the resources folder (?)
// add selective RuleSet/Vocabulary export capability
// do not use hardcoded BizTalkRuleEngineDb database name

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Import", "Policy", DefaultParameterSetName = "PathParameterSet")]
    public class ImportPolicyCommand : BizTalkPathAndObjectCmdlet
    {
        private string source_ = String.Empty;

        [Parameter(Mandatory = true)]
        [ValidateNotNullOrEmpty]
        public string Source
        {
            get { return source_; }
            set { source_ = value; }
        }

        public ImportPolicyCommand() : base(true)
        {}

        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsApplication;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsApplication btsApplication = btsObject as BtsApplication;
                btsApplication.ImportPolicy(source_);
            }

            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidArgument, btsObject));
            }
        }
    }
}
