using System;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Start", "SendPort", DefaultParameterSetName = "PathParameterSet")]
    public class StartSendPortCommand : BizTalkPathAndObjectCmdlet
    {
        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsSendPort;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsSendPort btsSendPort = btsObject as BtsSendPort;
                RegisterCatalog(btsSendPort.Catalog);
                btsSendPort.Start();
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidOperation, btsObject));
            }
        }

        protected override void EndProcessing()
        {
            SaveChanges();
        }
    }
}
