using System;
using System.Collections.Generic;
using System.Management.Automation;
using System.Management.Automation.Provider;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Stop", "HostInstance", DefaultParameterSetName = "PathParameterSet")]
    public class StopHostInstanceCommand : BizTalkPathAndObjectCmdlet
    {
        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsHostInstance;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsHostInstance btsHostInstance = btsObject as BtsHostInstance;
                btsHostInstance.Stop();
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidOperation, btsObject));
            }
        }
    }
}
