﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Stop", "Orchestration", DefaultParameterSetName = "PathParameterSet")]
    public class StopOrchestrationCommand : BizTalkPathAndObjectCmdlet
    {
        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsOrchestration;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                BtsOrchestration btsOrchestration = btsObject as BtsOrchestration;
                RegisterCatalog(btsOrchestration.Catalog);
                btsOrchestration.Stop();
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidOperation, btsObject));
            }
        }

        protected override void EndProcessing()
        {
            SaveChanges();
        }
    }
}
