﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Management.Automation;
using System.Globalization;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions.Cdmlets
{
    [Cmdlet("Terminate", "ServiceInstance", DefaultParameterSetName = "PathParameterSet")]
    public class TerminateServiceInstanceCommand : BizTalkPathAndObjectCmdlet
    {
        protected override bool ValidateBtsType(object btsObject)
        {
            return btsObject is BtsServiceInstance;
        }

        protected override void ProcessItem(object btsObject)
        {
            try
            {
                (btsObject as BtsServiceInstance)
                    .Terminate();
            }
            catch (Exception e)
            {
                WriteError(new ErrorRecord(e, "0", ErrorCategory.InvalidOperation, btsObject));
            }
        }
    }
}
