using System;
using System.Management.Automation;

using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    class NewHandlerDynamicParameters
    {
        private string hostname_ = String.Empty;
        private BtsHandlerDirection direction_ = BtsHandlerDirection.Receive;
        private SwitchParameter default_ = false;
        private string customProps_ = String.Empty;

        [Parameter(Mandatory = true)]
        public string HostName
        {
            get { return hostname_; }
            set { hostname_ = value; }
        }

        [Parameter(Mandatory = false)]
        public SwitchParameter Default
        {
            get { return default_; }
            set { default_ = value; }
        }

        [Parameter(Mandatory = true)]
        public BtsHandlerDirection Direction
        {
            get { return direction_; }
            set { direction_ = value; }
        }

        [Parameter(Mandatory = false)]
        public string CustomProps
        {
            get { return customProps_; }
            set { customProps_ = value; }
        }
    }
}
