using System;
using System.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    class NewHostInstanceDynamicParameters
    {
        private string host_ = String.Empty;
        private string server_ = Environment.MachineName;
        protected PSCredential credential_;

        // we use a custom Credentials property (note the extra s)
        // since -Credential property is not supported in any core CmdLets
        [Parameter(Mandatory = true)]
        public PSCredential Credentials
        {
            get { return credential_; }
            set { credential_ = value; }
        }

        [Parameter(Mandatory = true)]
        public string HostName
        {
            get { return host_; }
            set { host_ = value; }
        }

        [Parameter]
        public string RunningServer
        {
            get { return server_; }
            set { server_ = value; }
        }
    }
}
