using System;
using System.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    class NewResourceDynamicParameters
    {
        private string source_ = String.Empty;
        private string target_ = String.Empty;
        private string environment_ = String.Empty;
        private string arguments_ = String.Empty;
        private bool overwrite_ = false;

        private SwitchParameter gacOnAdd_;
        private SwitchParameter gacOnInstall_;
        private SwitchParameter gacOnImport_;

        private SwitchParameter regasm_;
        private SwitchParameter regsvcs_;

        private SwitchParameter regSvr32_;

        [Parameter(Mandatory = true)]
        public string SourceLocation
        {
            get { return source_; }
            set { source_ = value; }
        }

        [Parameter]
        public SwitchParameter Overwrite
        {
            get { return overwrite_; }
            set { overwrite_ = true; }
        }

        [Parameter]
        public string DestinationLocation
        {
            get { return target_; }
            set { target_ = value; }
        }

        [Parameter]
        public string TargetEnvironment
        {
            get { return environment_; }
            set { environment_ = value; }
        }

        [Parameter]
        public string Arguments
        {
            get { return arguments_; }
            set { arguments_ = value; }
        }

        [Parameter]
        public SwitchParameter GacOnAdd
        {
            get { return gacOnAdd_; }
            set { gacOnAdd_ = value; }
        }

        [Parameter]
        public SwitchParameter GacOnInstall
        {
            get { return gacOnInstall_; }
            set { gacOnInstall_ = value; }
        }

        [Parameter]
        public SwitchParameter GacOnImport
        {
            get { return gacOnImport_; }
            set { gacOnImport_ = value; }
        }

        [Parameter]
        public SwitchParameter Regasm
        {
            get { return regasm_; }
            set { regasm_ = value; }
        }

        [Parameter]
        public SwitchParameter Regsvcs
        {
            get { return regsvcs_; }
            set { regsvcs_ = value; }
        }

        [Parameter]
        public SwitchParameter RegSvr32
        {
            get { return regSvr32_; }
            set { regSvr32_ = value; }
        }
    }
}
