using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class AllArtifactsFolder : Folder
    {
        internal AllArtifactsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("All Artifacts"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();
            objects.Add(new OrchestrationsFolder(this.Parent));
            objects.Add(new PoliciesFolder(this.Parent));
            objects.Add(new PipelinesFolder(this.Parent));
            objects.Add(new ReceiveLocationsFolder(this.Parent));
            objects.Add(new ReceivePortsFolder(this.Parent));
            objects.Add(new ResourcesFolder(this.Parent));
            objects.Add(new SchemasFolder(this.Parent));
            objects.Add(new SendPortGroupsFolder(this.Parent));
            objects.Add(new SendPortsFolder(this.Parent));
            return objects.ToArray();
        }
    }
}
