using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class BackReferencesFolder : Folder
    {
        internal BackReferencesFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Back References"))
        {
        }

        private new BtsApplication Parent
        {
            get { return (base.Parent.Item as BtsApplication); }
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            foreach (BtsReference btsReference in Parent.BackReferences)
                objects.Add(new BizTalkFactory.PowerShell.Extensions.BackReference(btsReference));

            return objects.ToArray();
        }
    }
}
