using System;
using System.Collections.Generic;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class Folder : BizTalkObject
    {
        private BizTalkObject parent_;

        internal Folder(BizTalkObject parent, FolderContainer folderContainer)
            : base(folderContainer, true)
        {
            parent_ = parent;
        }

        public virtual BizTalkObject Parent { get { return parent_; } }

        public override string Name
        {
            get { return ((base.Item as FolderContainer).Name); }
        }

        public override BizTalkObject GetItem(string name)
        {
            BizTalkObject[] objects = GetChildItems(false);
            foreach (BizTalkObject item in objects)
                if (String.Compare(item.Name, name, StringComparison.InvariantCultureIgnoreCase) == 0)
                    return item;

            throw new ArgumentException("Unable to find the specified item");
        }
    }
}
