using System;
using System.Collections.Generic;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class MessagesFolder : Folder
    {
        internal MessagesFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Messages"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            string database = (PSDriveInfo as BizTalkDriveInfo).Database;
            string instance = (PSDriveInfo as BizTalkDriveInfo).Instance;

            BtsCatalog btsCatalog = BtsCatalog.Connect(instance, database);

            List<BizTalkObject> objects = new List<BizTalkObject>();

            BtsMessageCollection btsMessageCollection = new BtsMessageCollection(btsCatalog);
            foreach (BtsMessage btsMessage in btsMessageCollection.Collection)
                objects.Add(new Message(btsMessage));

            return objects.ToArray();
        }
    }
}
