using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class Orchestration : BizTalkObject
    {
        internal Orchestration(object item)
            : base(item)
        {
            System.Diagnostics.Debug.Assert(item is BtsOrchestration);
        }

        private new BtsOrchestration Item
        {
            get { return (base.Item as BtsOrchestration); }
        }

        public override string Name
        {
            get { return Item.Name; }
        }

        public override void RemoveItem(bool recurse)
        {
            BtsCatalog btsCatalog = this.Item.Catalog;
            this.Item.Application.RemoveOrchestration(this.Item);
            btsCatalog.SaveChanges();
        }
    }
}
