using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class OrchestrationsFolder : Folder
    {
        internal OrchestrationsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Orchestrations"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsOrchestration btsOrchestration in btsApplication.Orchestrations)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.Orchestration(btsOrchestration));
            }

            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsOrchestration btsOrchestration in btsCatalog.Orchestrations)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.Orchestration(btsOrchestration));
            }

            else
                throw new ArgumentException();

            return objects.ToArray();
        }
    }
}
