using System;
using System.Collections.Generic;

using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class PartiesFolder : Folder
    {
        internal PartiesFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Parties"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            string database = (PSDriveInfo as BizTalkDriveInfo).Database;
            string instance = (PSDriveInfo as BizTalkDriveInfo).Instance;

            BtsCatalog btsCatalog = BtsCatalog.Connect(instance, database);

            BtsPartyCollection btsPartyCollection = new BtsPartyCollection(btsCatalog);

            List<BizTalkObject> objects = new List<BizTalkObject>();

            foreach (BtsParty party in btsPartyCollection)
                objects.Add(new Party(party));

            return objects.ToArray();
        }
    }
}
