﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class Pipeline : BizTalkObject
    {
        internal Pipeline(object item)
            : base(item)
        {
            System.Diagnostics.Debug.Assert(item is BtsPipeline);
        }

        private new BtsPipeline Item
        {
            get { return (base.Item as BtsPipeline); }
        }

        public override string Name
        {
            get { return Item.Name; }
        }

        public override void RemoveItem(bool recurse)
        {
            this.Item.Application.RemovePipeline(this.Item);
        }

        public override void SetPropertyValue(PSPropertyInfo propertyInfo)
        {
            if (!propertyInfo.IsSettable)
            {
                throw new ArgumentException("Property is not settable");
            }

            switch (propertyInfo.Name.ToLower())
            {
                case "description":
                    this.Item.Description = propertyInfo.Value.ToString();
                    break;
            }

            this.Item.Catalog.SaveChanges();
        }
    }
}
