﻿using System;
using System.Collections.Generic;
using System.Text;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class PipelinesFolder : Folder
    {
        internal PipelinesFolder(BizTalkObject parent)
            : base (parent, new FolderContainer("Pipelines"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsPipeline btsPipeline in btsApplication.Pipelines)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.Pipeline(btsPipeline));
            }

            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsPipeline btsPipeline in btsCatalog.Pipelines)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.Pipeline(btsPipeline));
            }

            return objects.ToArray();
        }
    }
}
