using System;
using System.Collections.Generic;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class PlatformSettingsFolder : Folder
    {
        internal PlatformSettingsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Platform Settings"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();
            objects.Add(new HostsFolder(this));
            objects.Add(new HostInstancesFolder(this));
            objects.Add(new AdaptersFolder(this));
            return objects.ToArray();
        }
    }
}
