using System;
using System.Collections.Generic;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class ReceiveLocation : BizTalkObject
    {
        internal ReceiveLocation(object item)
            : base(item)
        {
            System.Diagnostics.Debug.Assert(item is BtsReceiveLocation);
        }

        private new BtsReceiveLocation Item
        {
            get { return (base.Item as BtsReceiveLocation); }
        }

        public override string Name
        {
            get { return Item.Name; }
        }

        public override void RemoveItem(bool recurse)
        {
            BtsCatalog btsCatalog = this.Item.Catalog;
            this.Item.ReceivePort.RemoveReceiveLocation(this.Item);
            btsCatalog.SaveChanges();
        }

        public override void SetPropertyValue(PSPropertyInfo propertyInfo)
        {
            if (!propertyInfo.IsSettable)
            {
                throw new ArgumentException("Property is not settable");
            }

            switch (propertyInfo.Name.ToLower())
            {
                case "name":
                    this.Item.SetName(propertyInfo.Value.ToString());
                    break;
                case "description":
                    this.Item.Description = propertyInfo.Value.ToString();
                    break;
                case "address":
                    this.Item.Address = propertyInfo.Value.ToString();
                    break;
                case "publicaddress":
                    this.Item.PublicAddress = propertyInfo.Value.ToString();
                    break;
            }

            this.Item.Catalog.SaveChanges();
        }
    }
}
