using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class ReceiveLocationsFolder : Folder
    {
        internal ReceiveLocationsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Receive Locations"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsReceiveLocation btsReceiveLocation in btsApplication.ReceiveLocations)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.ReceiveLocation(btsReceiveLocation));
            }

            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsReceiveLocation btsReceiveLocation in btsCatalog.ReceiveLocations)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.ReceiveLocation(btsReceiveLocation));
            }

            return objects.ToArray();
       }
    }
}
