﻿using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class ReceivePortsFolder : Folder
    {
        internal ReceivePortsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Receive Ports"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsReceivePort btsReceivePort in btsApplication.ReceivePorts)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.ReceivePort(btsReceivePort));
            }

            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsReceivePort btsReceivePort in btsCatalog.ReceivePorts)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.ReceivePort(btsReceivePort));
            }

            return objects.ToArray();
        }
    }
}
