using System;
using System.Collections.Generic;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class ReferenceBase : BizTalkObject
    {
        internal ReferenceBase(object item)
            : base(item)
        {
            System.Diagnostics.Debug.Assert(item is BtsReference);
        }

        protected new BtsReference Item
        {
            get { return (base.Item as BtsReference); }
        }

        public override string Name
        {
            get { return Item.Name; }
        }
   }

    internal class Reference : ReferenceBase
    {
        internal Reference(object item)
            : base(item)
        {
            System.Diagnostics.Debug.Assert(item is BtsReference);
        }

        public override void RemoveItem(bool recurse)
        {
            this.Item.Application.RemoveReference(this.Item.Catalog.Applications[this.Item.Name]);
            this.Item.Catalog.SaveChanges();
        }
    }

    internal class BackReference : ReferenceBase
    {
        internal BackReference(object item)
            : base(item)
        {
            System.Diagnostics.Debug.Assert(item is BtsReference);
        }
    }
}
