using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class ReferencesFolder : Folder
    {
        internal ReferencesFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("References"))
        {
        }

        private new BtsApplication Parent
        {
            get { return (base.Parent.Item as BtsApplication); }
        }

        public override object NewItemDynamicParameters
        {
            get { return new NewReferenceDynamicParameters(); }
        }

        public override BizTalkObject NewItem(string name, object parameters)
        {
            NewReferenceDynamicParameters dynamicParams = (parameters as NewReferenceDynamicParameters);

            Parent.AddReference(dynamicParams.Reference);
            Parent.Catalog.SaveChanges();

            return new Application(dynamicParams.Reference);
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            foreach (BtsReference btsReference in  Parent.References)
                objects.Add(new BizTalkFactory.PowerShell.Extensions.Reference(btsReference));

            return objects.ToArray();
        }
    }
}
