using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class SchemasFolder : Folder
    {
        internal SchemasFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Schemas"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsSchema btsSchema in btsApplication.Schemas)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.Schema(btsSchema));
            }

            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsSchema btsSchema in btsCatalog.Schemas)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.Schema(btsSchema));
            }

            return objects.ToArray();
        }
    }
}
