﻿using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class SendPortGroupsFolder : Folder
    {
        internal SendPortGroupsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Send Port Groups"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsSendPortGroup btsSendPortGroup in btsApplication.SendPortGroups)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.SendPortGroup(btsSendPortGroup));
            }

            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsSendPortGroup btsSendPortGroup in btsCatalog.SendPortGroups)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.SendPortGroup(btsSendPortGroup));
            }

            return objects.ToArray();
        }
    }
}
