using System;
using System.Collections.Generic;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class SendPortsFolder : Folder
    {
        internal SendPortsFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Send Ports"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            List<BizTalkObject> objects = new List<BizTalkObject>();

            if (this.Parent.Item is BtsApplication)
            {
                BtsApplication btsApplication = this.Parent.Item as BtsApplication;
                foreach (BtsSendPort btsSendPort in btsApplication.SendPorts)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.SendPort(btsSendPort));
            }
            else if (this.Parent.Item is BtsCatalog)
            {
                BtsCatalog btsCatalog = this.Parent.Item as BtsCatalog;
                foreach (BtsSendPort btsSendPort in btsCatalog.SendPorts)
                    objects.Add(new BizTalkFactory.PowerShell.Extensions.SendPort(btsSendPort));
            }

            return objects.ToArray();
        }
    }
}
