using System;
using System.Collections.Generic;
using System.Management.Automation;
using BizTalkFactory.Management.Automation;

namespace BizTalkFactory.PowerShell.Extensions
{
    internal class ServiceInstancesFolder : Folder
    {
        internal ServiceInstancesFolder(BizTalkObject parent)
            : base(parent, new FolderContainer("Service Instances"))
        {
        }

        public override BizTalkObject[] GetChildItems(bool recurse)
        {
            string database = (PSDriveInfo as BizTalkDriveInfo).Database;
            string instance = (PSDriveInfo as BizTalkDriveInfo).Instance;

            BtsCatalog btsCatalog = BtsCatalog.Connect(instance, database);

            List<BizTalkObject> objects = new List<BizTalkObject>();

            BtsServiceInstanceCollection btsInstanceCollection = new BtsServiceInstanceCollection(btsCatalog);
            foreach (BtsServiceInstance btsInstance in btsInstanceCollection.Collection)
                objects.Add(new ServiceInstance(btsInstance));

            return objects.ToArray();
        }
    }
}
