﻿using System;
using System.Runtime.InteropServices.ComTypes;

namespace BizTalkFactory.Runtime.InteropServices
{
    public sealed class ComponentCategory
    {
        public Guid CategoryID { get; set; }
        public UInt32 LocaleID { get; set; }
        public String Description { get; set; }

        private ComponentCategory()
        {
        }

        public static ComponentCategory FromCATEGORYINFO(CATEGORYINFO catInfo)
        {
            var category = new ComponentCategory();
            category.CategoryID = catInfo.catid;
            category.LocaleID = catInfo.lcid;
            category.Description = catInfo.szDescription;

            return category;
        }
    }
}
